<link rel="import" href="/extern/bower_components/polymer/polymer.html">
<link rel="import" href="/extern/bower_components/paper-toast/paper-toast.html">
<link rel="import" href="/extern/bower_components/paper-dialog/paper-dialog.html">
<link rel="import" href="/extern/bower_components/paper-dialog-scrollable/paper-dialog-scrollable.html">
<link rel="import" href="/extern/bower_components/paper-button/paper-button.html">
<link rel="import" href="throws-toast.html">
<link rel="import" href="/ts/common-elements/reset-css/reset-css.html">

<!--

`ag-toaster` can globally receive messages to show to the user.
These can be displayed as a [paper-toast](https://elements.polymer-project.org/elements/paper-toast) on the bottom of the screen. A [paper-toast](https://elements.polymer-project.org/elements/paper-toast) with clickable options. Or a [paper-dialog](https://elements.polymer-project.org/elements/paper-dialog) forcing the user to choose an option.

Only one `ag-toaster` should exist per project.
To be able to send messages to this element, regardless of location, implement the 'throwsToast' behavior in your element.

Example:

    <ag-toaster></ag-toaster>

Element example:

    <link rel="import" href="/ts/ajaxell/html/elements/ag-toaster/throws-toast.html">

    ...

    behaviors: [throwsToast],

    ...

    this.throwToast({
      'type': 'error',
      'message': 'this is a big error, you will need to choose something',
      'options': ['save the world', 'make dinosaurs'],
      'blocking': true,
      'callback': function(response) {
        console.log("you have chosen to", response);
      }
    });


@demo demo/index.html


-->




<dom-module id="ag-toaster">
    <template>
      <style include="reset-css"></style>
      <style>
paper-dialog h2{margin:0 !important;padding-top:1em !important;padding-bottom:.5em !important}paper-dialog[type="warning"] h2{background-color:var(--paper-orange-500, orange)}paper-dialog[type="error"] h2{background-color:var(--paper-red-500, #A70303)}paper-toast[type="warning"]{background-color:var(--paper-orange-500, orange)}paper-toast[type="error"]{background-color:var(--paper-red-500, #A70303)}

</style>

      <paper-dialog modal id="modal" on-iron-overlay-closed="_modalClosed" type$="{{_toast.type}}">
        <h2>{{_toast.type}}</h2>
        <paper-dialog-scrollable>{{_toast.message}}</paper-dialog-scrollable>
        <div class="buttons">
          <template is="dom-repeat" items="{{_toast.options}}" as="option">
            <paper-button on-click="_dialogButtonClick">{{option}}</paper-button>
          </template>
        </div>
      </paper-dialog>

      <paper-toast id="toast" text="{{_toast.message}}" type$="{{_toast.type}}" duration="{{duration}}">
        <template is="dom-repeat" items="{{_toast.options}}" as="option">
          <paper-button on-click="_toastButtonClick">{{option}}</paper-button>
        </template>
      </paper-toast>

    </template>

    <script>
Polymer({is:"ag-toaster",properties:{_toast:{type:Object,value:function(){return{}},observer:"_toastChanged"},_toastHideDelay:Object,_toastTimer:Object,duration:{type:Number,value:3e3},_stack:{type:Array,value:function(){return[]}},log:{type:Array,value:function(){return[]}}},observers:["_stackChanged(_stack.splices)"],_toastChanged:function(){this.updateStyles()},_dialogButtonClick:function(event,details){this.log[0].answer=event.model.option,this._toast.callback(event.model.option),this._toast={},this.$.modal.close()},_toastButtonClick:function(event,details){this.cancelAsync(this._toastTimer),this.log[0].answer=event.model.option,this._toast.callback(event.model.option),this.$.toast.hide(),this._toastHideDelay=this.async(function(){this._toast={},this._stackChanged()},200)},throwToast:function(toast,sender){toast.sender=sender,toast.timestamp=new Date,this.push("_stack",toast)},_oldToastIsHigherPriority:function(){var currentToast=this._toast,newToast=this._stack[0],currentPriority=0;"warning"==currentToast.type?currentPriority=1:"error"==currentToast.type&&(currentPriority=2);var newPriority=0;return"warning"==newToast.type?newPriority=1:"error"==newToast.type&&(newPriority=2),currentPriority>newPriority},_stackChanged:function(){this._stack.length>0&&!this._toast.blocking&&!this._oldToastIsHigherPriority()&&(this.cancelAsync(this._toastHideDelay),this.$.toast.opened?(this.cancelAsync(this._toastTimer),this.$.toast.hide(),this._toastTimeout(),this._toastHideDelay=this.async(function(){this._nextToast()},200)):this._nextToast())},_toastTimeout:function(){this._toast.callback&&this._toast.callback(null)},_nextToast:function(){this._toast=this._stack[0],this._toast&&this._toast.type&&this._toast.message?(this.unshift("log",this._toast),this._toast.options&&!this._toast.callback&&(console.error(this._toast,"toast has options but provides no callback"),this._toast.callback=function(){console.error("no callback was specified for this toast")}),this._toast.blocking?this.$.modal.open():(this.$.toast.show(),this._toastTimer=this.async(function(){this._toastTimeout(),this._toastHideDelay=this.async(function(){this._toast={},this._stackChanged()},200),this._stackChanged()},this.duration))):(console.error(this,"received an invalid toast: ",this._toast),this._toast={}),this.shift("_stack")},_modalClosed:function(){this._stackChanged()},showLog:function(){console.log("showing toaster logs");for(var i=0;i<this.log.length;i++){var toast=this.log[i],output=toast.message+"\n";toast.answer&&(output+="-> user responded: "+toast.answer+"\n"),output+="-> received at "+toast.timestamp+" by ","info"==toast.type?console.info(output,toast.sender):"warning"==toast.type?console.warn(output,toast.sender):"error"==toast.type?console.error(output,toast.sender):console.log(output,toast.sender)}},attached:function(){"undefined"==typeof toaster?window.toaster=this:console.error(this,"Trying to register as toaster, but another is already registerd",toaster)}});
</script>
</dom-module>
